/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of MCP23017.xs. Do not edit this file, edit MCP23017.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MCP23017.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <errno.h>
#include <fcntl.h>
#include <linux/i2c.h>
#include <linux/i2c-dev.h>
#include <sys/ioctl.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "mcp23017.h"
#include "bit.h"

/* setup functions */

int GPIO_getFd (int expanderAddr){

    int fd;

    if ((fd = open("/dev/i2c-1", O_RDWR)) < 0) {
        close(fd);
        printf("Couldn't open the device: %s\n", strerror(errno));
        croak("...this is a fatal error\n");
    }

    if (ioctl(fd, I2C_SLAVE_FORCE, expanderAddr) < 0) {
        close(fd);
        printf(
                "Couldn't find device at addr %d: %s\n",
                expanderAddr,
                strerror(errno)
        );
        exit(-1);
    }

    _establishI2C(fd);

    return fd;
}

void _establishI2C (int fd){

    int buf[1] = { 0x00 };

    if (write(fd, buf, 1) != 1){
        close(fd);
        printf("Error: Received no ACK bit, couldn't establish connection!");
        exit(-1);
    }
}

/* register operations */

void _checkRegisterReadOnly (uint8_t reg){
    uint8_t readOnlyRegisters[6] = {0x0A, 0X0B, 0x0E, 0x0F, 0x10, 0x11};

    for (int i=0; i < sizeof(readOnlyRegisters); i++){
        if (reg == readOnlyRegisters[i]){
            warn("error: register 0x%x is read-only...\n", reg);
            croak("Attempt to write to read-only register failed\n");
        }
    }
}

int _skipRegisterReadOnly (uint8_t reg){
    uint8_t readOnlyRegisters[6] = {0x0A, 0X0B, 0x0E, 0x0F, 0x10, 0x11};

    for (int i=0; i < sizeof(readOnlyRegisters); i++){
        if (reg == readOnlyRegisters[i]){
            return 1;
        }
    }
    return 0;
}

int GPIO_getRegister (int fd, int reg){

    uint8_t buf[1];
    buf[0] = reg;

    if ((write(fd, buf, 1)) != 1){
        close(fd);
        croak(
            "Could not write register pointer %d: %s\n",
            reg,
            strerror(errno)
        );
    }

    if ((read(fd, buf, 1)) != 1){
        close(fd);
        croak("Could not read register %d: %s\n", reg, strerror(errno));
    }

    return buf[0];
}

int GPIO_getRegisterBit (int fd, int reg, int bit){
    bit = GPIO__pinBit(bit);
    int regData = GPIO_getRegister(fd, (int) reg);
    return bitGet(regData, bit, bit);
}

int GPIO_getRegisterBits (int fd, int reg, int msb, int lsb){
    return bitGet(GPIO_getRegister(fd, reg), msb, lsb);
}

int GPIO_setRegister(int fd, int reg, int value, char* name){
    _checkRegisterReadOnly(reg);

    uint8_t buf[2] = {reg, value};

    if ((write(fd, buf, sizeof(buf))) != 2){
        close(fd);
        printf(
                "Could not write to the %s register: %s\n",
                name,
                strerror(errno)
        );
        exit(-1);
    }

    return 0;
}

/* pin functions */

int GPIO__pinBit (int pin){
    if (pin < 0 || pin > 15){
        croak("pin '%d' is out of bounds. Pins 0-15 are available\n");
    }

    // since we're dealing with a register per bank,
    // We need to know where in the double register to
    // look

    return pin < 8 ? pin : pin - 8;
}

bool GPIO_readPin (int fd, int pin){
    int reg = pin < 8 ? reg = MCP23017_GPIOA : MCP23017_GPIOB;
    int bit = GPIO__pinBit(pin);

    return (bool) GPIO_getRegisterBit(fd, reg, bit);
}

void GPIO_writePin (int fd, int pin, bool state){
    int reg = pin < 8 ? reg = MCP23017_GPIOA : MCP23017_GPIOB;
    int bit = GPIO__pinBit(pin);
    int value;

    if (state == HIGH){
        value = bitOn(GPIO_getRegister(fd, reg), bit);
    }
    else {
        value = bitOff(GPIO_getRegister(fd, reg), bit);
    }

    GPIO_setRegister(fd, reg, value, "writePin()");
}

void GPIO_pinMode (int fd, int pin, int mode){
    int reg = pin < 8 ? (int) MCP23017_IODIRA : (int) MCP23017_IODIRB;
    int bit = GPIO__pinBit(pin);
    int value;

    if (mode == INPUT){
        value = bitOn(GPIO_getRegister(fd, reg), bit);

    }
    else {
        value = bitOff(GPIO_getRegister(fd, reg), bit);
    }

    GPIO_setRegister(fd, reg, value, "pinMode()");
}

void GPIO_pullUp (int fd, int pin, int state){
    int reg = pin < 8 ? MCP23017_GPPUA : MCP23017_GPPUB;
    int bit = GPIO__pinBit(pin);
    int value;

    if (state == HIGH){
        value = bitOn(GPIO_getRegister(fd, reg), bit);
    }
    else {
        value = bitOff(GPIO_getRegister(fd, reg), bit);
    }

    GPIO_setRegister(fd, reg, value, "pullUp()");
}

/* operational functions */

void GPIO_clean (int fd){

    for (int i = 0; i < 0x16; i++){
        if (_skipRegisterReadOnly(i)){
            continue;
        }

        if (i == MCP23017_IODIRA || i == MCP23017_IODIRB){
            // direction registers get set back to INPUT
            GPIO_setRegister(fd, (int) i, (int) 0xFF, "IODIR");
            continue;
        }
        GPIO_setRegister(fd, i, 0x00, "rest");
    }
}

#line 225 "MCP23017.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 369 "MCP23017.c"

XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getFd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getFd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "expanderAddr");
    {
	int	expanderAddr = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = GPIO_getFd(expanderAddr);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getRegister); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getRegister)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, reg");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = GPIO_getRegister(fd, reg);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getRegisterBit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getRegisterBit)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, reg, bit");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	bit = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = GPIO_getRegisterBit(fd, reg, bit);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getRegisterBits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_getRegisterBits)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "fd, reg, msb, lsb");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	msb = (int)SvIV(ST(2))
;
	int	lsb = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = GPIO_getRegisterBits(fd, reg, msb, lsb);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_setRegister); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_setRegister)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "fd, reg, value, name");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	value = (int)SvIV(ST(2))
;
	char*	name = (char *)SvPV_nolen(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = GPIO_setRegister(fd, reg, value, name);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017__pinBit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017__pinBit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pin");
    {
	int	pin = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = GPIO__pinBit(pin);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_readPin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_readPin)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, pin");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	pin = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = GPIO_readPin(fd, pin);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_writePin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_writePin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, pin, state");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	pin = (int)SvIV(ST(1))
;
	int	state = (int)SvIV(ST(2))
;

	GPIO_writePin(fd, pin, state);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_pinMode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_pinMode)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, pin, mode");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	pin = (int)SvIV(ST(1))
;
	int	mode = (int)SvIV(ST(2))
;

	GPIO_pinMode(fd, pin, mode);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_pullUp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_pullUp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, pin, state");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	pin = (int)SvIV(ST(1))
;
	int	state = (int)SvIV(ST(2))
;

	GPIO_pullUp(fd, pin, state);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_clean); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__GPIOExpander__MCP23017_clean)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	fd = (int)SvIV(ST(0))
;
#line 287 "MCP23017.xs"
        I32* temp;
#line 597 "MCP23017.c"
#line 289 "MCP23017.xs"
        temp = PL_markstack_ptr++;
        GPIO_clean(fd);
        if (PL_markstack_ptr != temp) {
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY;
        }
        return;
#line 606 "MCP23017.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_RPi__GPIOExpander__MCP23017); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_RPi__GPIOExpander__MCP23017)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("RPi::GPIOExpander::MCP23017::getFd", XS_RPi__GPIOExpander__MCP23017_getFd);
        newXS_deffile("RPi::GPIOExpander::MCP23017::getRegister", XS_RPi__GPIOExpander__MCP23017_getRegister);
        newXS_deffile("RPi::GPIOExpander::MCP23017::getRegisterBit", XS_RPi__GPIOExpander__MCP23017_getRegisterBit);
        newXS_deffile("RPi::GPIOExpander::MCP23017::getRegisterBits", XS_RPi__GPIOExpander__MCP23017_getRegisterBits);
        newXS_deffile("RPi::GPIOExpander::MCP23017::setRegister", XS_RPi__GPIOExpander__MCP23017_setRegister);
        newXS_deffile("RPi::GPIOExpander::MCP23017::_pinBit", XS_RPi__GPIOExpander__MCP23017__pinBit);
        newXS_deffile("RPi::GPIOExpander::MCP23017::readPin", XS_RPi__GPIOExpander__MCP23017_readPin);
        newXS_deffile("RPi::GPIOExpander::MCP23017::writePin", XS_RPi__GPIOExpander__MCP23017_writePin);
        newXS_deffile("RPi::GPIOExpander::MCP23017::pinMode", XS_RPi__GPIOExpander__MCP23017_pinMode);
        newXS_deffile("RPi::GPIOExpander::MCP23017::pullUp", XS_RPi__GPIOExpander__MCP23017_pullUp);
        newXS_deffile("RPi::GPIOExpander::MCP23017::clean", XS_RPi__GPIOExpander__MCP23017_clean);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

